﻿using System.Net;
using System.Web.Mvc;
using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Layers;
using ThinkGeo.MapSuite.Mvc;
using ThinkGeo.MapSuite.Shapes;

namespace _8675.Controllers
{
    public class HomeController : Controller
    {
        // GET: Home
        public ActionResult Index()
        {
            Map map = new Map("Map1",
               new System.Web.UI.WebControls.Unit(800, System.Web.UI.WebControls.UnitType.Pixel),
               new System.Web.UI.WebControls.Unit(600, System.Web.UI.WebControls.UnitType.Pixel));

            map.MapUnit = GeographyUnit.DecimalDegree;

            WmsRasterLayer wms = new WmsRasterLayer(new System.Uri("https://worldmapkit3.thinkgeo.com/WmsServer.axd"));
            wms.ActiveLayerNames.Add("OSMWorldMapKitLayer");
            wms.ActiveStyleNames.Add("WorldMapKitDefaultStyle");
            wms.Parameters.Add("projection", "EPSG:4326");
            wms.Parameters.Add("units", "degress");

            wms.SendingWebRequest += Wms_SendingWebRequest;

            LayerOverlay wmsOverlay = new LayerOverlay();
            wmsOverlay.Layers.Add(wms);
            map.CustomOverlays.Add(wmsOverlay);
            map.CurrentExtent = new RectangleShape(-135, 45, -22.5, 0);

            return View(map);
        }

        private void Wms_SendingWebRequest(object sender, SendingWebRequestEventArgs e)
        {   
            e.WebRequest = HttpWebRequest.Create(e.WebRequest.RequestUri.ToString().Replace("http://", "https://"));            
        }
    }
}